<?php

class EventEntity
{

    private $username;
    private $item_id;
    private $item_type;
    private $item_name;
    private $tags;
    private $time;
    private $severity;
    private $message;
    private $status;

    /**
     * @return mixed
     */
    public function getUsername()
    {
        return $this->username;
    }


    /**
     * @param $username
     * @return $this
     */
    public function setUsername($username)
    {
        $this->username = $username;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getItemId()
    {
        return $this->item_id;
    }

    /**
     * @param $item_id
     * @return $this
     */
    public function setItemId($item_id)
    {
        $this->item_id = $item_id;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getItemType()
    {
        return $this->item_type;
    }


    /**
     * @param $item_type
     * @return $this
     */
    public function setItemType($item_type)
    {
        $this->item_type = $item_type;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getItemName()
    {
        return $this->item_name;
    }


    /**
     * @param $item_name
     * @return $this
     */
    public function setItemName($item_name)
    {
        $this->item_name = $item_name;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getTags()
    {
        return $this->tags;
    }

    /**
     * @param $tags
     * @return $this
     */
    public function setTags($tags)
    {
        $this->tags = $tags;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getTime()
    {
        return $this->time;
    }

    /**
     * @param $time
     * @return $this
     */
    public function setTime($time)
    {
        if (!is_int($time)) {
            $time = strtotime($time);
        }
        $this->time = $time;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getSeverity()
    {
        return $this->severity;
    }


    /**
     * @param $severity
     * @return $this
     */
    public function setSeverity($severity)
    {
        $this->severity = $severity;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getMessage()
    {
        return $this->message;
    }


    /**
     * @param $message
     * @return $this
     */
    public function setMessage($message)
    {
        $this->message = $message;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getStatus()
    {
        return $this->status;
    }


    /**
     * @param $status
     * @return $this
     */
    public function setStatus($status)
    {
        $this->status = $status;
        return $this;
    }

    public function toArray()
    {
        return [
            'username' => $this->username,
            'item_id' => $this->item_id,
            'item_type' => $this->item_type,
            'item_name' => $this->item_name,
            'tags' => $this->tags,
            'time' => $this->time,
            'severity' => $this->severity,
            'message' => $this->message,
            'status' => $this->status,
        ];
    }
}